<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>2. 作成したプログラム &mdash; 計算機実習 1.0 documentation</title>
    
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '1.0',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <link rel="top" title="計算機実習 1.0 documentation" href="../index.html" />
    <link rel="up" title="計算機実習 問題12-4 継続型ランダムウォーク" href="12-4.html" />
    <link rel="next" title="3. 実習課題" href="experiment.html" />
    <link rel="prev" title="1. シミュレーションの目的" href="purpose.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="experiment.html" title="3. 実習課題"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="purpose.html" title="1. シミュレーションの目的"
             accesskey="P">previous</a> |</li>
        <li><a href="../index.html">計算機実習 1.0 documentation</a> &raquo;</li>
          <li><a href="12-4.html" accesskey="U">計算機実習 問題12-4 継続型ランダムウォーク</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="id1">
<h1>2. 作成したプログラム<a class="headerlink" href="#id1" title="Permalink to this headline">¶</a></h1>
<p>本シミュレーションで作成したプログラムを以下に示す。</p>
<ul class="simple">
<li>継続型ランダムウォークのシミュレーション-計算部</li>
</ul>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>  1
  2
  3
  4
  5
  6
  7
  8
  9
 10
 11
 12
 13
 14
 15
 16
 17
 18
 19
 20
 21
 22
 23
 24
 25
 26
 27
 28
 29
 30
 31
 32
 33
 34
 35
 36
 37
 38
 39
 40
 41
 42
 43
 44
 45
 46
 47
 48
 49
 50
 51
 52
 53
 54
 55
 56
 57
 58
 59
 60
 61
 62
 63
 64
 65
 66
 67
 68
 69
 70
 71
 72
 73
 74
 75
 76
 77
 78
 79
 80
 81
 82
 83
 84
 85
 86
 87
 88
 89
 90
 91
 92
 93
 94
 95
 96
 97
 98
 99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! /usr/bin/env python</span>
<span class="c"># -*- coding:utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>

<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="kn">as</span> <span class="nn">plt</span>

<span class="k">class</span> <span class="nc">HistoryDependentRW</span><span class="p">():</span>
    
    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">alpha</span><span class="o">=</span><span class="mf">0.5</span><span class="p">,</span> <span class="n">l</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">nwalkers</span><span class="o">=</span><span class="mi">1000</span><span class="p">,</span> <span class="n">x0</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">jump</span><span class="o">=</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">)):</span>
        <span class="sd">&quot;&quot;&quot; Initialize the values.</span>
<span class="sd">        </span>
<span class="sd">        alpha    : probability that a particle moves the same direction of the before one</span>
<span class="sd">        l        : step length</span>
<span class="sd">        nwalkers : number of trials</span>
<span class="sd">        x0       : initial position</span>
<span class="sd">        jump     : jump length [p=alpha, p=1-alpha] (default: jump=[1,1])</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">alpha</span> <span class="o">=</span> <span class="n">alpha</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">l</span> <span class="o">=</span> <span class="n">l</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span> <span class="o">=</span> <span class="n">nwalkers</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">x0</span> <span class="o">=</span> <span class="n">x0</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">jump</span><span class="o">=</span><span class="n">jump</span>
        
    <span class="k">def</span> <span class="nf">random_walk_d1</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">N</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Caluculate the displacements of each walkers.</span>
<span class="sd">        </span>
<span class="sd">        N : A list of walk steps</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">x</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">([</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span><span class="p">,</span> <span class="nb">max</span><span class="p">(</span><span class="n">N</span><span class="p">)],</span> <span class="s">&#39;i&#39;</span><span class="p">)</span>
        <span class="n">x_direction</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">([</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span><span class="p">,</span> <span class="nb">max</span><span class="p">(</span><span class="n">N</span><span class="p">)],</span> <span class="s">&#39;i&#39;</span><span class="p">)</span>
        <span class="n">p</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">random</span><span class="p">([</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span><span class="p">,</span> <span class="nb">max</span><span class="p">(</span><span class="n">N</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span> <span class="c"># generate random number in [0,1)</span>
        <span class="n">alpha</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">alpha</span>
        <span class="n">l</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">l</span>
        <span class="n">x0</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x0</span>
        <span class="n">j0</span><span class="p">,</span> <span class="n">j1</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">jump</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="bp">self</span><span class="o">.</span><span class="n">jump</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
              
        <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span><span class="p">):</span>
            <span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span> <span class="o">=</span> <span class="n">x0</span>
            <span class="n">x_direction</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span> <span class="o">=</span> <span class="o">+</span><span class="mi">1</span> <span class="k">if</span> <span class="n">n</span> <span class="o">&lt;</span> <span class="nb">int</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span><span class="o">/</span><span class="mi">2</span><span class="p">)</span> <span class="k">else</span> <span class="o">-</span><span class="mi">1</span>
            <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="nb">max</span><span class="p">(</span><span class="n">N</span><span class="p">)):</span>
                <span class="k">if</span> <span class="n">p</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">&lt;</span> <span class="n">alpha</span><span class="p">:</span>
                    <span class="n">x_direction</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">j0</span><span class="o">*</span><span class="n">x_direction</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">x_direction</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="o">-</span><span class="n">j1</span><span class="o">*</span><span class="n">x_direction</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> 
                <span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">+</span> <span class="n">x_direction</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">x</span> <span class="o">=</span> <span class="n">x</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">N</span> <span class="o">=</span> <span class="n">N</span>
    
    <span class="k">def</span> <span class="nf">calc_ave</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Caluculate the average of displacements after max(N) steps.</span>
<span class="sd">        </span>
<span class="sd">        You can call the results by &quot;self.N&quot;, &quot;self.x_ave&quot;, and &quot;self.x_2_ave&quot;</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">x_ave</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">sum</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span><span class="o">/</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span><span class="o">*</span><span class="mf">1.</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">x_2_ave</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">sum</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="o">**</span><span class="mi">2</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span><span class="o">/</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span><span class="o">*</span><span class="mf">1.</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">variance_x</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_2_ave</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_ave</span><span class="o">**</span><span class="mi">2</span>
      
    <span class="k">def</span> <span class="nf">show</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Show the graph.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">fig</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="s">&#39;random walk&#39;</span><span class="p">,</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">8</span><span class="p">,</span><span class="mi">8</span><span class="p">))</span>
        
        <span class="n">x_ave</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">x_ave</span><span class="p">[</span><span class="n">nvalue</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="k">for</span> <span class="n">nvalue</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">N</span><span class="p">]</span>
        <span class="n">x_2_ave</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">x_2_ave</span><span class="p">[</span><span class="n">nvalue</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="k">for</span> <span class="n">nvalue</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">N</span><span class="p">]</span>
        <span class="n">variance_x</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">variance_x</span><span class="p">[</span><span class="n">nvalue</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="k">for</span> <span class="n">nvalue</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">N</span><span class="p">]</span>
        
        <span class="n">ax1</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">311</span><span class="p">)</span>
        <span class="n">ax1</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">N</span><span class="p">,</span> <span class="n">x_ave</span><span class="p">)</span>
        <span class="n">ax1</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s">r&#39;$&lt;x(N)&gt;$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>

        <span class="n">ax2</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">312</span><span class="p">)</span>
        <span class="n">ax2</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">N</span><span class="p">,</span> <span class="n">x_2_ave</span><span class="p">)</span>
        <span class="n">ax2</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s">r&#39;$&lt;x^{2}(N)&gt;$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>

        <span class="n">ax3</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">313</span><span class="p">)</span>
        <span class="n">ax3</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s">r&#39;$&lt;\Delta x^{2}(N)&gt;$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
        <span class="n">ax3</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">N</span><span class="p">,</span> <span class="n">variance_x</span><span class="p">)</span>
        <span class="n">ax3</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">(</span><span class="s">r&#39;$N$&#39;</span><span class="p">)</span>

        <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>

    <span class="k">def</span> <span class="nf">caluculate_prob</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">_n</span><span class="p">):</span>
        <span class="n">N</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">N</span><span class="p">)</span>
        <span class="n">x</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x</span>
        <span class="n">count_box</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">([</span><span class="n">N</span><span class="p">,</span> <span class="mi">2</span><span class="o">*</span><span class="n">N</span><span class="o">+</span><span class="mi">1</span><span class="p">],</span> <span class="s">&#39;f&#39;</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">N</span><span class="p">):</span>
            <span class="k">for</span> <span class="n">walker</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span><span class="p">):</span>
                <span class="n">count_box</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">N</span><span class="o">+</span><span class="n">x</span><span class="p">[</span><span class="n">walker</span><span class="p">][</span><span class="n">n</span><span class="p">]]</span> <span class="o">=</span> <span class="n">count_box</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">N</span><span class="o">+</span><span class="n">x</span><span class="p">[</span><span class="n">walker</span><span class="p">][</span><span class="n">n</span><span class="p">]]</span> <span class="o">+</span> <span class="mi">1</span>
        <span class="n">prob</span> <span class="o">=</span> <span class="n">count_box</span><span class="o">/</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span>
        
        <span class="k">def</span> <span class="nf">show_for_n</span><span class="p">(</span><span class="n">_n</span><span class="p">):</span>
            
            <span class="n">xmin</span> <span class="o">=</span> <span class="o">-</span><span class="n">N</span>
            <span class="n">xmax</span> <span class="o">=</span> <span class="n">N</span>
            <span class="k">for</span> <span class="n">_x</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">2</span><span class="o">*</span><span class="n">N</span><span class="o">+</span><span class="mi">1</span><span class="p">):</span>
                <span class="k">if</span> <span class="n">prob</span><span class="p">[</span><span class="n">_n</span><span class="p">][</span><span class="n">_x</span><span class="p">]</span> <span class="o">!=</span> <span class="mi">0</span><span class="p">:</span>
                    <span class="n">xmin</span><span class="p">,</span> <span class="n">xmax</span> <span class="o">=</span> <span class="n">_x</span><span class="o">-</span><span class="n">N</span><span class="p">,</span> <span class="n">N</span><span class="o">-</span><span class="n">_x</span>
                    <span class="k">break</span>
            
            <span class="n">xmargin</span> <span class="o">=</span> <span class="n">xmax</span><span class="o">*</span><span class="mf">0.1</span>
            <span class="n">ymax</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">amax</span><span class="p">(</span><span class="n">prob</span><span class="p">[</span><span class="n">_n</span><span class="p">])</span>
            <span class="n">ymargin</span> <span class="o">=</span> <span class="n">ymax</span><span class="o">*</span><span class="mf">0.1</span>
                    
            <span class="n">fig</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="s">&#39;probability&#39;</span><span class="p">)</span>
            <span class="n">ax</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">111</span><span class="p">)</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">grid</span><span class="p">()</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">(</span><span class="n">xmin</span><span class="o">-</span><span class="n">xmargin</span><span class="p">,</span><span class="n">xmax</span><span class="o">+</span><span class="n">xmargin</span><span class="p">)</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">ymax</span><span class="o">+</span><span class="n">ymargin</span><span class="p">)</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="o">-</span><span class="n">N</span><span class="p">,</span> <span class="n">N</span><span class="o">+</span><span class="mi">1</span><span class="p">),</span> <span class="n">prob</span><span class="p">[</span><span class="n">_n</span><span class="p">])</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">(</span><span class="s">r&#39;$x$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s">r&#39;$P(x,N)$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
        
        <span class="n">show_for_n</span><span class="p">(</span><span class="n">_n</span><span class="p">)</span>
        
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>継続型ランダムウォークのシミュレーション-実行部</li>
</ul>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! /usr/bin/env python</span>
<span class="c"># -*- coding:utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>

<span class="kn">from</span> <span class="nn">HistoryDependentRW</span> <span class="kn">import</span> <span class="n">HistoryDependentRW</span>
    
<span class="k">def</span> <span class="nf">ex_a1</span><span class="p">():</span>
    <span class="n">rw</span> <span class="o">=</span> <span class="n">HistoryDependentRW</span><span class="p">()</span>
    <span class="n">N</span> <span class="o">=</span> <span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">512</span><span class="p">)</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">random_walk_d1</span><span class="p">(</span><span class="n">N</span><span class="p">)</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">calc_ave</span><span class="p">()</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>

<span class="k">def</span> <span class="nf">ex_a2</span><span class="p">():</span>
    <span class="n">rw</span> <span class="o">=</span> <span class="n">HistoryDependentRW</span><span class="p">()</span>
    <span class="n">N</span> <span class="o">=</span> <span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">512</span><span class="p">)</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">random_walk_d1</span><span class="p">(</span><span class="n">N</span><span class="p">)</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">caluculate_prob</span><span class="p">(</span><span class="n">_n</span><span class="o">=</span><span class="mi">400</span><span class="p">)</span>

<span class="k">def</span> <span class="nf">ex_a3</span><span class="p">():</span>
    <span class="n">rw</span> <span class="o">=</span> <span class="n">HistoryDependentRW</span><span class="p">(</span><span class="n">alpha</span><span class="o">=</span><span class="mf">0.5</span><span class="p">)</span>
    <span class="n">N</span> <span class="o">=</span> <span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">512</span><span class="p">)</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">random_walk_d1</span><span class="p">(</span><span class="n">N</span><span class="p">)</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">calc_ave</span><span class="p">()</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
    
<span class="k">def</span> <span class="nf">ex_b1</span><span class="p">(</span><span class="n">alpha</span><span class="o">=</span><span class="mf">0.25</span><span class="p">):</span>
    <span class="n">rw</span> <span class="o">=</span> <span class="n">HistoryDependentRW</span><span class="p">(</span><span class="n">alpha</span><span class="o">=</span><span class="n">alpha</span><span class="p">)</span>
    <span class="n">N</span> <span class="o">=</span> <span class="p">[</span><span class="mi">8</span><span class="p">,</span><span class="mi">64</span><span class="p">,</span><span class="mi">256</span><span class="p">,</span><span class="mi">512</span><span class="p">]</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">random_walk_d1</span><span class="p">(</span><span class="n">N</span><span class="p">)</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">calc_ave</span><span class="p">()</span>
    <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="n">N</span><span class="p">:</span>
        <span class="k">print</span> <span class="s">&#39;&lt;\Delta x^{2}(&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">n</span><span class="p">)</span> <span class="o">+</span> <span class="s">&#39;)&gt; = &#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">rw</span><span class="o">.</span><span class="n">variance_x</span><span class="p">[</span><span class="n">n</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span>

<span class="k">def</span> <span class="nf">ex_b2</span><span class="p">(</span><span class="n">alpha</span><span class="o">=</span><span class="mf">0.25</span><span class="p">):</span>
    <span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="kn">as</span> <span class="nn">plt</span>
    <span class="kn">import</span> <span class="nn">scipy.optimize</span> <span class="kn">as</span> <span class="nn">optimize</span>
    <span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
    
    <span class="n">rw</span> <span class="o">=</span> <span class="n">HistoryDependentRW</span><span class="p">(</span><span class="n">alpha</span><span class="o">=</span><span class="n">alpha</span><span class="p">)</span>
    <span class="n">N</span> <span class="o">=</span> <span class="nb">xrange</span><span class="p">(</span><span class="mi">100</span><span class="p">,</span><span class="mi">10001</span><span class="p">)</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">random_walk_d1</span><span class="p">(</span><span class="n">N</span><span class="p">)</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">calc_ave</span><span class="p">()</span>
    
    <span class="n">variance_x</span> <span class="o">=</span> <span class="p">[</span><span class="n">rw</span><span class="o">.</span><span class="n">variance_x</span><span class="p">[</span><span class="n">nvalue</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="k">for</span> <span class="n">nvalue</span> <span class="ow">in</span> <span class="n">N</span><span class="p">]</span>
    
    <span class="n">ln_N</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">log</span><span class="p">(</span><span class="n">N</span><span class="p">)</span>
    <span class="n">ln_variance_x</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">log</span><span class="p">(</span><span class="n">variance_x</span><span class="p">)</span>
    <span class="n">parameter0</span><span class="o">=</span><span class="p">[</span><span class="mf">1.0</span><span class="p">,</span> <span class="mf">1.0</span><span class="p">]</span> <span class="c"># initial values for optimize</span>

    <span class="k">def</span> <span class="nf">fit_func</span><span class="p">(</span><span class="n">parameter0</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">):</span>
        <span class="n">a</span> <span class="o">=</span> <span class="n">parameter0</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
        <span class="n">b</span> <span class="o">=</span> <span class="n">parameter0</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
        <span class="n">residual</span> <span class="o">=</span> <span class="n">y</span> <span class="o">-</span> <span class="p">(</span><span class="n">a</span><span class="o">*</span><span class="n">x</span><span class="o">+</span><span class="n">b</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">residual</span>

    <span class="n">result</span><span class="o">=</span><span class="n">optimize</span><span class="o">.</span><span class="n">leastsq</span><span class="p">(</span><span class="n">fit_func</span><span class="p">,</span> <span class="n">parameter0</span><span class="p">,</span> <span class="n">args</span><span class="o">=</span><span class="p">(</span><span class="n">ln_N</span><span class="p">,</span><span class="n">ln_variance_x</span><span class="p">))</span>
    <span class="k">print</span> <span class="s">&#39;nu = &#39;</span><span class="p">,</span> <span class="n">result</span><span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span><span class="o">/</span><span class="mf">2.</span>

    <span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s">r&#39;$N$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s">r&#39;$&lt;\Delta x^{2}(N)&gt;$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">xscale</span><span class="p">(</span><span class="s">&#39;log&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">yscale</span><span class="p">(</span><span class="s">&#39;log&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">axis</span><span class="p">(</span><span class="s">&#39;equal&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">N</span><span class="p">,</span> <span class="n">variance_x</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
    
<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&#39;__main__&#39;</span><span class="p">:</span>
    
    <span class="n">ex_b2</span><span class="p">()</span>
    
</pre></div>
</td></tr></table></div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="purpose.html"
                        title="previous chapter">1. シミュレーションの目的</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="experiment.html"
                        title="next chapter">3. 実習課題</a></p>
  <h3>This Page</h3>
  <ul class="this-page-menu">
    <li><a href="../_sources/12-4_history-dependent_rw/program.txt"
           rel="nofollow">Show Source</a></li>
  </ul>
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="experiment.html" title="3. 実習課題"
             >next</a> |</li>
        <li class="right" >
          <a href="purpose.html" title="1. シミュレーションの目的"
             >previous</a> |</li>
        <li><a href="../index.html">計算機実習 1.0 documentation</a> &raquo;</li>
          <li><a href="12-4.html" >計算機実習 問題12-4 継続型ランダムウォーク</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2014, Shotaro Fujimoto.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.2.2.
    </div>
  </body>
</html>